]> git.notmuchmail.org Git - notmuch/blob - test/test-lib.sh
test: add function die () and have use of it in add_email_corpus ()
[notmuch] / test / test-lib.sh
1 #
2 # Copyright (c) 2005 Junio C Hamano
3 # Copyright (c) 2010 Notmuch Developers
4 #
5 # This program is free software: you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation, either version 2 of the License, or
8 # (at your option) any later version.
9 #
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
13 # GNU General Public License for more details.
14 #
15 # You should have received a copy of the GNU General Public License
16 # along with this program.  If not, see https://www.gnu.org/licenses/ .
17
18 if [ ${BASH_VERSINFO[0]} -lt 4 ]; then
19     echo "Error: The notmuch test suite requires a bash version >= 4.0"
20     echo "due to use of associative arrays within the test suite."
21     echo "Please try again with a newer bash (or help us fix the"
22     echo "test suite to be more portable). Thanks."
23     exit 1
24 fi
25
26 # Make sure echo builtin does not expand backslash-escape sequences by default.
27 shopt -u xpg_echo
28
29 this_test=${0##*/}
30 this_test=${this_test%.sh}
31 this_test_bare=${this_test#T[0-9][0-9][0-9]-}
32
33 # if --tee was passed, write the output not only to the terminal, but
34 # additionally to the file test-results/$BASENAME.out, too.
35 case "$GIT_TEST_TEE_STARTED, $* " in
36 done,*)
37         # do not redirect again
38         ;;
39 *' --tee '*|*' --va'*)
40         mkdir -p test-results
41         BASE=test-results/$this_test
42         (GIT_TEST_TEE_STARTED=done ${SHELL-sh} "$0" "$@" 2>&1;
43          echo $? > $BASE.exit) | tee $BASE.out
44         test "$(cat $BASE.exit)" = 0
45         exit
46         ;;
47 esac
48
49 # Save STDOUT to fd 6 and STDERR to fd 7.
50 exec 6>&1 7>&2
51 # Make xtrace debugging (when used) use redirected STDERR, with verbose lead:
52 BASH_XTRACEFD=7
53 export PS4='+(${BASH_SOURCE}:${LINENO}): ${FUNCNAME[0]:+${FUNCNAME[0]}(): }'
54
55 # Keep the original TERM for say_color and test_emacs
56 ORIGINAL_TERM=$TERM
57
58 # dtach(1) provides more capable terminal environment to anything
59 # that requires more than dumb terminal...
60 [ x"${TERM:-dumb}" = xdumb ] && DTACH_TERM=vt100 || DTACH_TERM=$TERM
61
62 # For repeatability, reset the environment to known value.
63 LANG=C
64 LC_ALL=C
65 PAGER=cat
66 TZ=UTC
67 TERM=dumb
68 export LANG LC_ALL PAGER TERM TZ
69 GIT_TEST_CMP=${GIT_TEST_CMP:-diff -u}
70 if [[ ( -n "$TEST_EMACS" && -z "$TEST_EMACSCLIENT" ) || \
71       ( -z "$TEST_EMACS" && -n "$TEST_EMACSCLIENT" ) ]]; then
72     echo "error: must specify both or neither of TEST_EMACS and TEST_EMACSCLIENT" >&2
73     exit 1
74 fi
75 TEST_EMACS=${TEST_EMACS:-${EMACS:-emacs}}
76 TEST_EMACSCLIENT=${TEST_EMACSCLIENT:-emacsclient}
77 TEST_CC=${TEST_CC:-cc}
78 TEST_CFLAGS=${TEST_CFLAGS:-"-g -O0"}
79
80 # Protect ourselves from common misconfiguration to export
81 # CDPATH into the environment
82 unset CDPATH
83
84 unset GREP_OPTIONS
85
86 # For emacsclient
87 unset ALTERNATE_EDITOR
88
89 # Convenience
90 #
91 # A regexp to match 5 and 40 hexdigits
92 _x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
93 _x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
94
95 _x04='[0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
96 _x32="$_x04$_x04$_x04$_x04$_x04$_x04$_x04$_x04"
97
98 # Each test should start with something like this, after copyright notices:
99 #
100 # test_description='Description of this test...
101 # This test checks if command xyzzy does the right thing...
102 # '
103 # . ./test-lib.sh || exit 1
104
105 [ "x$ORIGINAL_TERM" != "xdumb" ] && (
106                 TERM=$ORIGINAL_TERM &&
107                 export TERM &&
108                 [ -t 1 ] &&
109                 tput bold >/dev/null 2>&1 &&
110                 tput setaf 1 >/dev/null 2>&1 &&
111                 tput sgr0 >/dev/null 2>&1
112         ) &&
113         color=t
114
115 while test "$#" -ne 0
116 do
117         case "$1" in
118         -d|--d|--de|--deb|--debu|--debug)
119                 debug=t; shift ;;
120         -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
121                 immediate=t; shift ;;
122         -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
123                 GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
124         -h|--h|--he|--hel|--help)
125                 help=t; shift ;;
126         -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
127                 verbose=t; shift ;;
128         -q|--q|--qu|--qui|--quie|--quiet)
129                 quiet=t; shift ;;
130         --with-dashes)
131                 with_dashes=t; shift ;;
132         --no-color)
133                 color=; shift ;;
134         --no-python)
135                 # noop now...
136                 shift ;;
137         --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
138                 valgrind=t; verbose=t; shift ;;
139         --tee)
140                 shift ;; # was handled already
141         --root=*)
142                 root=$(expr "z$1" : 'z[^=]*=\(.*\)')
143                 shift ;;
144         *)
145                 echo "error: unknown test option '$1'" >&2; exit 1 ;;
146         esac
147 done
148
149 if test -n "$debug"; then
150     print_subtest () {
151         printf " %-4s" "[$((test_count - 1))]"
152     }
153 else
154     print_subtest () {
155         true
156     }
157 fi
158
159 if test -n "$color"; then
160         say_color () {
161                 (
162                 TERM=$ORIGINAL_TERM
163                 export TERM
164                 case "$1" in
165                         error) tput bold; tput setaf 1;; # bold red
166                         skip)  tput bold; tput setaf 2;; # bold green
167                         pass)  tput setaf 2;;            # green
168                         info)  tput setaf 3;;            # brown
169                         *) test -n "$quiet" && return;;
170                 esac
171                 shift
172                 printf " "
173                 printf "$@"
174                 tput sgr0
175                 print_subtest
176                 )
177         }
178 else
179         say_color() {
180                 test -z "$1" && test -n "$quiet" && return
181                 shift
182                 printf " "
183                 printf "$@"
184                 print_subtest
185         }
186 fi
187
188 error () {
189         say_color error "error: $*\n"
190         GIT_EXIT_OK=t
191         exit 1
192 }
193
194 say () {
195         say_color info "$*"
196 }
197
198 test "${test_description}" != "" ||
199 error "Test script did not set test_description."
200
201 if test "$help" = "t"
202 then
203         echo "Tests ${test_description}"
204         exit 0
205 fi
206
207 test_description_printed=
208 print_test_description ()
209 {
210         test -z "$test_description_printed" || return 0
211         echo
212         echo $this_test: "Testing ${test_description}"
213         test_description_printed=1
214 }
215 if [ -z "$NOTMUCH_TEST_QUIET" ]
216 then
217         print_test_description
218 fi
219
220 test_failure=0
221 test_count=0
222 test_fixed=0
223 test_broken=0
224 test_success=0
225
226 _exit_common () {
227         code=$?
228         trap - EXIT
229         set +ex
230         rm -rf "$TEST_TMPDIR"
231 }
232
233 trap_exit () {
234         _exit_common
235         if test -n "$GIT_EXIT_OK"
236         then
237                 exit $code
238         else
239                 exec >&6
240                 say_color error '%-6s' FATAL
241                 echo " $test_subtest_name"
242                 echo
243                 echo "Unexpected exit while executing $0. Exit code $code."
244                 exit 1
245         fi
246 }
247
248 trap_signal () {
249         _exit_common
250         echo >&6 "FATAL: $0: interrupted by signal" $((code - 128))
251         exit $code
252 }
253
254 die () {
255         _exit_common
256         exec >&6
257         say_color error '%-6s' FATAL
258         echo " $*"
259         echo
260         echo "Unexpected exit while executing $0."
261         exit 1
262 }
263
264 GIT_EXIT_OK=
265 # Note: TEST_TMPDIR *NOT* exported!
266 TEST_TMPDIR=$(mktemp -d "${TMPDIR:-/tmp}/notmuch-test-$$.XXXXXX")
267 trap 'trap_exit' EXIT
268 trap 'trap_signal' HUP INT TERM
269
270 test_decode_color () {
271         sed     -e 's/.\[1m/<WHITE>/g' \
272                 -e 's/.\[31m/<RED>/g' \
273                 -e 's/.\[32m/<GREEN>/g' \
274                 -e 's/.\[33m/<YELLOW>/g' \
275                 -e 's/.\[34m/<BLUE>/g' \
276                 -e 's/.\[35m/<MAGENTA>/g' \
277                 -e 's/.\[36m/<CYAN>/g' \
278                 -e 's/.\[m/<RESET>/g'
279 }
280
281 q_to_nul () {
282         perl -pe 'y/Q/\000/'
283 }
284
285 q_to_cr () {
286         tr Q '\015'
287 }
288
289 append_cr () {
290         sed -e 's/$/Q/' | tr Q '\015'
291 }
292
293 remove_cr () {
294         tr '\015' Q | sed -e 's/Q$//'
295 }
296
297 # Generate a new message in the mail directory, with a unique message
298 # ID and subject. The message is not added to the index.
299 #
300 # After this function returns, the filename of the generated message
301 # is available as $gen_msg_filename and the message ID is available as
302 # $gen_msg_id .
303 #
304 # This function supports named parameters with the bash syntax for
305 # assigning a value to an associative array ([name]=value). The
306 # supported parameters are:
307 #
308 #  [dir]=directory/of/choice
309 #
310 #       Generate the message in directory 'directory/of/choice' within
311 #       the mail store. The directory will be created if necessary.
312 #
313 #  [filename]=name
314 #
315 #       Store the message in file 'name'. The default is to store it
316 #       in 'msg-<count>', where <count> is three-digit number of the
317 #       message.
318 #
319 #  [body]=text
320 #
321 #       Text to use as the body of the email message
322 #
323 #  '[from]="Some User <user@example.com>"'
324 #  '[to]="Some User <user@example.com>"'
325 #  '[subject]="Subject of email message"'
326 #  '[date]="RFC 822 Date"'
327 #
328 #       Values for email headers. If not provided, default values will
329 #       be generated instead.
330 #
331 #  '[cc]="Some User <user@example.com>"'
332 #  [reply-to]=some-address
333 #  [in-reply-to]=<message-id>
334 #  [references]=<message-id>
335 #  [content-type]=content-type-specification
336 #  '[header]=full header line, including keyword'
337 #
338 #       Additional values for email headers. If these are not provided
339 #       then the relevant headers will simply not appear in the
340 #       message.
341 #
342 #  '[id]=message-id'
343 #
344 #       Controls the message-id of the created message.
345 gen_msg_cnt=0
346 gen_msg_filename=""
347 gen_msg_id=""
348 generate_message ()
349 {
350     # This is our (bash-specific) magic for doing named parameters
351     local -A template="($@)"
352     local additional_headers
353
354     gen_msg_cnt=$((gen_msg_cnt + 1))
355     if [ -z "${template[filename]}" ]; then
356         gen_msg_name="msg-$(printf "%03d" $gen_msg_cnt)"
357     else
358         gen_msg_name=${template[filename]}
359     fi
360
361     if [ -z "${template[id]}" ]; then
362         gen_msg_id="${gen_msg_name%:2,*}@notmuch-test-suite"
363     else
364         gen_msg_id="${template[id]}"
365     fi
366
367     if [ -z "${template[dir]}" ]; then
368         gen_msg_filename="${MAIL_DIR}/$gen_msg_name"
369     else
370         gen_msg_filename="${MAIL_DIR}/${template[dir]}/$gen_msg_name"
371         mkdir -p "$(dirname "$gen_msg_filename")"
372     fi
373
374     if [ -z "${template[body]}" ]; then
375         template[body]="This is just a test message (#${gen_msg_cnt})"
376     fi
377
378     if [ -z "${template[from]}" ]; then
379         template[from]="Notmuch Test Suite <test_suite@notmuchmail.org>"
380     fi
381
382     if [ -z "${template[to]}" ]; then
383         template[to]="Notmuch Test Suite <test_suite@notmuchmail.org>"
384     fi
385
386     if [ -z "${template[subject]}" ]; then
387         if [ -n "$test_subtest_name" ]; then
388             template[subject]="$test_subtest_name"
389         else
390             template[subject]="Test message #${gen_msg_cnt}"
391         fi
392     elif [ "${template[subject]}" = "@FORCE_EMPTY" ]; then
393         template[subject]=""
394     fi
395
396     if [ -z "${template[date]}" ]; then
397         # we use decreasing timestamps here for historical reasons;
398         # the existing test suite when we converted to unique timestamps just
399         # happened to have signicantly fewer failures with that choice.
400         local date_secs=$((978709437 - gen_msg_cnt))
401         # printf %(..)T is bash 4.2+ feature. use perl fallback if needed...
402         TZ=UTC printf -v template[date] "%(%a, %d %b %Y %T %z)T" $date_secs 2>/dev/null ||
403             template[date]=`perl -le 'use POSIX "strftime";
404                                 @time = gmtime '"$date_secs"';
405                                 print strftime "%a, %d %b %Y %T +0000", @time'`
406     fi
407
408     additional_headers=""
409     if [ ! -z "${template[header]}" ]; then
410         additional_headers="${template[header]}
411 ${additional_headers}"
412     fi
413
414     if [ ! -z "${template[reply-to]}" ]; then
415         additional_headers="Reply-To: ${template[reply-to]}
416 ${additional_headers}"
417     fi
418
419     if [ ! -z "${template[in-reply-to]}" ]; then
420         additional_headers="In-Reply-To: ${template[in-reply-to]}
421 ${additional_headers}"
422     fi
423
424     if [ ! -z "${template[cc]}" ]; then
425         additional_headers="Cc: ${template[cc]}
426 ${additional_headers}"
427     fi
428
429     if [ ! -z "${template[bcc]}" ]; then
430         additional_headers="Bcc: ${template[bcc]}
431 ${additional_headers}"
432     fi
433
434     if [ ! -z "${template[references]}" ]; then
435         additional_headers="References: ${template[references]}
436 ${additional_headers}"
437     fi
438
439     if [ ! -z "${template[content-type]}" ]; then
440         additional_headers="Content-Type: ${template[content-type]}
441 ${additional_headers}"
442     fi
443
444     if [ ! -z "${template[content-transfer-encoding]}" ]; then
445         additional_headers="Content-Transfer-Encoding: ${template[content-transfer-encoding]}
446 ${additional_headers}"
447     fi
448
449     # Note that in the way we're setting it above and using it below,
450     # `additional_headers' will also serve as the header / body separator
451     # (empty line in between).
452
453     cat <<EOF >"$gen_msg_filename"
454 From: ${template[from]}
455 To: ${template[to]}
456 Message-Id: <${gen_msg_id}>
457 Subject: ${template[subject]}
458 Date: ${template[date]}
459 ${additional_headers}
460 ${template[body]}
461 EOF
462 }
463
464 # Generate a new message and add it to the database.
465 #
466 # All of the arguments and return values supported by generate_message
467 # are also supported here, so see that function for details.
468 add_message ()
469 {
470     generate_message "$@" &&
471     notmuch new > /dev/null
472 }
473
474 # Deliver a message with emacs and add it to the database
475 #
476 # Uses emacs to generate and deliver a message to the mail store.
477 # Accepts arbitrary extra emacs/elisp functions to modify the message
478 # before sending, which is useful to doing things like attaching files
479 # to the message and encrypting/signing.
480 emacs_deliver_message ()
481 {
482     local subject="$1"
483     local body="$2"
484     shift 2
485     # before we can send a message, we have to prepare the FCC maildir
486     mkdir -p "$MAIL_DIR"/sent/{cur,new,tmp}
487     # eval'ing smtp-dummy --background will set smtp_dummy_pid
488     smtp_dummy_pid=
489     eval `$TEST_DIRECTORY/smtp-dummy --background sent_message`
490     test -n "$smtp_dummy_pid" || return 1
491
492     test_emacs \
493         "(let ((message-send-mail-function 'message-smtpmail-send-it)
494                (mail-host-address \"example.com\")
495                (smtpmail-smtp-server \"localhost\")
496                (smtpmail-smtp-service \"25025\"))
497            (notmuch-mua-mail)
498            (message-goto-to)
499            (insert \"test_suite@notmuchmail.org\nDate: 01 Jan 2000 12:00:00 -0000\")
500            (message-goto-subject)
501            (insert \"${subject}\")
502            (message-goto-body)
503            (insert \"${body}\")
504            $@
505            (notmuch-mua-send-and-exit))"
506
507     # In case message was sent properly, client waits for confirmation
508     # before exiting and resuming control here; therefore making sure
509     # that server exits by sending (KILL) signal to it is safe.
510     kill -9 $smtp_dummy_pid
511     notmuch new >/dev/null
512 }
513
514 # Pretend to deliver a message with emacs. Really save it to a file
515 # and add it to the database
516 #
517 # Uses emacs to generate and deliver a message to the mail store.
518 # Accepts arbitrary extra emacs/elisp functions to modify the message
519 # before sending, which is useful to doing things like attaching files
520 # to the message and encrypting/signing.
521 emacs_fcc_message ()
522 {
523     local subject="$1"
524     local body="$2"
525     shift 2
526     # before we can send a message, we have to prepare the FCC maildir
527     mkdir -p "$MAIL_DIR"/sent/{cur,new,tmp}
528
529     test_emacs \
530         "(let ((message-send-mail-function (lambda () t))
531                (mail-host-address \"example.com\"))
532            (notmuch-mua-mail)
533            (message-goto-to)
534            (insert \"test_suite@notmuchmail.org\nDate: 01 Jan 2000 12:00:00 -0000\")
535            (message-goto-subject)
536            (insert \"${subject}\")
537            (message-goto-body)
538            (insert \"${body}\")
539            $@
540            (notmuch-mua-send-and-exit))" || return 1
541     notmuch new >/dev/null
542 }
543
544 # Generate a corpus of email and add it to the database.
545 #
546 # This corpus is fixed, (it happens to be 50 messages from early in
547 # the history of the notmuch mailing list), which allows for reliably
548 # testing commands that need to operate on a not-totally-trivial
549 # number of messages.
550 add_email_corpus ()
551 {
552     rm -rf ${MAIL_DIR}
553     if [ -d $TEST_DIRECTORY/corpus.mail ]; then
554         cp -a $TEST_DIRECTORY/corpus.mail ${MAIL_DIR}
555     else
556         cp -a $TEST_DIRECTORY/corpus ${MAIL_DIR}
557         notmuch new >/dev/null || die "'notmuch new' failed while adding email corpus"
558         cp -a ${MAIL_DIR} $TEST_DIRECTORY/corpus.mail
559     fi
560 }
561
562 test_begin_subtest ()
563 {
564     if [ -n "$inside_subtest" ]; then
565         exec 1>&6 2>&7          # Restore stdout and stderr
566         error "bug in test script: Missing test_expect_equal in ${BASH_SOURCE[1]}:${BASH_LINENO[0]}"
567     fi
568     test_subtest_name="$1"
569     test_reset_state_
570     # Redirect test output to the previously prepared file descriptors
571     # 3 and 4 (see below)
572     if test "$verbose" != "t"; then exec 4>test.output 3>&4; fi
573     exec >&3 2>&4
574     inside_subtest=t
575 }
576
577 # Pass test if two arguments match
578 #
579 # Note: Unlike all other test_expect_* functions, this function does
580 # not accept a test name. Instead, the caller should call
581 # test_begin_subtest before calling this function in order to set the
582 # name.
583 test_expect_equal ()
584 {
585         exec 1>&6 2>&7          # Restore stdout and stderr
586         inside_subtest=
587         test "$#" = 3 && { prereq=$1; shift; } || prereq=
588         test "$#" = 2 ||
589         error "bug in the test script: not 2 or 3 parameters to test_expect_equal"
590
591         output="$1"
592         expected="$2"
593         if ! test_skip "$test_subtest_name"
594         then
595                 if [ "$output" = "$expected" ]; then
596                         test_ok_
597                 else
598                         testname=$this_test.$test_count
599                         echo "$expected" > $testname.expected
600                         echo "$output" > $testname.output
601                         test_failure_ "$(diff -u $testname.expected $testname.output)"
602                 fi
603     fi
604 }
605
606 # Like test_expect_equal, but takes two filenames.
607 test_expect_equal_file ()
608 {
609         exec 1>&6 2>&7          # Restore stdout and stderr
610         inside_subtest=
611         test "$#" = 3 && { prereq=$1; shift; } || prereq=
612         test "$#" = 2 ||
613         error "bug in the test script: not 2 or 3 parameters to test_expect_equal"
614
615         file1="$1"
616         basename1=`basename "$file1"`
617         file2="$2"
618         basename2=`basename "$file2"`
619         if ! test_skip "$test_subtest_name"
620         then
621                 if diff -q "$file1" "$file2" >/dev/null ; then
622                         test_ok_
623                 else
624                         testname=$this_test.$test_count
625                         cp "$file1" "$testname.$basename1"
626                         cp "$file2" "$testname.$basename2"
627                         test_failure_ "$(diff -u "$testname.$basename1" "$testname.$basename2")"
628                 fi
629     fi
630 }
631
632 # Like test_expect_equal, but arguments are JSON expressions to be
633 # canonicalized before diff'ing.  If an argument cannot be parsed, it
634 # is used unchanged so that there's something to diff against.
635 test_expect_equal_json () {
636     # The test suite forces LC_ALL=C, but this causes Python 3 to
637     # decode stdin as ASCII.  We need to read JSON in UTF-8, so
638     # override Python's stdio encoding defaults.
639     output=$(echo "$1" | PYTHONIOENCODING=utf-8 $NOTMUCH_PYTHON -mjson.tool \
640         || echo "$1")
641     expected=$(echo "$2" | PYTHONIOENCODING=utf-8 $NOTMUCH_PYTHON -mjson.tool \
642         || echo "$2")
643     shift 2
644     test_expect_equal "$output" "$expected" "$@"
645 }
646
647 # Sort the top-level list of JSON data from stdin.
648 test_sort_json () {
649     PYTHONIOENCODING=utf-8 python -c \
650         "import sys, json; json.dump(sorted(json.load(sys.stdin)),sys.stdout)"
651 }
652
653 test_emacs_expect_t () {
654         test "$#" = 2 && { prereq=$1; shift; } || prereq=
655         test "$#" = 1 ||
656         error "bug in the test script: not 1 or 2 parameters to test_emacs_expect_t"
657
658         # Run the test.
659         if ! test_skip "$test_subtest_name"
660         then
661                 test_emacs "(notmuch-test-run $1)" >/dev/null
662
663                 # Restore state after the test.
664                 exec 1>&6 2>&7          # Restore stdout and stderr
665                 inside_subtest=
666
667                 # Report success/failure.
668                 result=$(cat OUTPUT)
669                 if [ "$result" = t ]
670                 then
671                         test_ok_
672                 else
673                         test_failure_ "${result}"
674                 fi
675         else
676                 # Restore state after the (non) test.
677                 exec 1>&6 2>&7          # Restore stdout and stderr
678                 inside_subtest=
679         fi
680 }
681
682 NOTMUCH_NEW ()
683 {
684     notmuch new "${@}" | grep -v -E -e '^Processed [0-9]*( total)? file|Found [0-9]* total file'
685 }
686
687 NOTMUCH_DUMP_TAGS ()
688 {
689     # this relies on the default format being batch-tag, otherwise some tests will break
690     notmuch dump --include=tags "${@}" | sed '/^#/d' | sort
691 }
692
693 notmuch_search_sanitize ()
694 {
695     perl -pe 's/("?thread"?: ?)("?)................("?)/\1\2XXX\3/'
696 }
697
698 notmuch_search_files_sanitize ()
699 {
700     notmuch_dir_sanitize
701 }
702
703 notmuch_dir_sanitize ()
704 {
705     sed -e "s,$MAIL_DIR,MAIL_DIR," -e "s,${PWD},CWD,g" "$@"
706 }
707
708 NOTMUCH_SHOW_FILENAME_SQUELCH='s,filename:.*/mail,filename:/XXX/mail,'
709 notmuch_show_sanitize ()
710 {
711     sed -e "$NOTMUCH_SHOW_FILENAME_SQUELCH"
712 }
713 notmuch_show_sanitize_all ()
714 {
715     sed \
716         -e 's| filename:.*| filename:XXXXX|' \
717         -e 's| id:[^ ]* | id:XXXXX |' | \
718         notmuch_date_sanitize
719 }
720
721 notmuch_json_show_sanitize ()
722 {
723     sed \
724         -e 's|"id": "[^"]*",|"id": "XXXXX",|g' \
725         -e 's|"Date": "Fri, 05 Jan 2001 [^"]*0000"|"Date": "GENERATED_DATE"|g' \
726         -e 's|"filename": "signature.asc",||g' \
727         -e 's|"filename": "/[^"]*",|"filename": "YYYYY",|g' \
728         -e 's|"timestamp": 97.......|"timestamp": 42|g'
729 }
730
731 notmuch_emacs_error_sanitize ()
732 {
733     local command=$1
734     shift
735     for file in "$@"; do
736         echo "=== $file ==="
737         cat "$file"
738     done | sed  \
739         -e 's/^\[.*\]$/[XXX]/' \
740         -e "s|^\(command: \)\{0,1\}/.*/$command|\1YYY/$command|"
741 }
742
743 notmuch_date_sanitize ()
744 {
745     sed \
746         -e 's/^Date: Fri, 05 Jan 2001 .*0000/Date: GENERATED_DATE/'
747 }
748
749 notmuch_uuid_sanitize ()
750 {
751     sed 's/[0-9a-f]\{8\}-[0-9a-f]\{4\}-[0-9a-f]\{4\}-[0-9a-f]\{4\}-[0-9a-f]\{12\}/UUID/g'
752 }
753
754 notmuch_built_with_sanitize ()
755 {
756     sed 's/^built_with[.]\(.*\)=.*$/built_with.\1=something/'
757 }
758
759 notmuch_config_sanitize ()
760 {
761     notmuch_dir_sanitize | notmuch_built_with_sanitize
762 }
763
764 # End of notmuch helper functions
765
766 # Use test_set_prereq to tell that a particular prerequisite is available.
767 # The prerequisite can later be checked for in two ways:
768 #
769 # - Explicitly using test_have_prereq.
770 #
771 # - Implicitly by specifying the prerequisite tag in the calls to
772 #   test_expect_{success,failure,code}.
773 #
774 # The single parameter is the prerequisite tag (a simple word, in all
775 # capital letters by convention).
776
777 test_set_prereq () {
778         satisfied="$satisfied$1 "
779 }
780 satisfied=" "
781
782 test_have_prereq () {
783         case $satisfied in
784         *" $1 "*)
785                 : yes, have it ;;
786         *)
787                 ! : nope ;;
788         esac
789 }
790
791 declare -A test_missing_external_prereq_
792 declare -A test_subtest_missing_external_prereq_
793
794 # declare prerequisite for the given external binary
795 test_declare_external_prereq () {
796         binary="$1"
797         test "$#" = 2 && name=$2 || name="$binary(1)"
798
799         if ! hash $binary 2>/dev/null; then
800                 test_missing_external_prereq_["${binary}"]=t
801                 eval "
802 $binary () {
803         test_subtest_missing_external_prereq_[\"${name}\"]=t
804         false
805 }"
806         fi
807 }
808
809 # Explicitly require external prerequisite.  Useful when binary is
810 # called indirectly (e.g. from emacs).
811 # Returns success if dependency is available, failure otherwise.
812 test_require_external_prereq () {
813         binary="$1"
814         if [[ ${test_missing_external_prereq_["${binary}"]} == t ]]; then
815                 # dependency is missing, call the replacement function to note it
816                 eval "$binary"
817         else
818                 true
819         fi
820 }
821
822 # You are not expected to call test_ok_ and test_failure_ directly, use
823 # the text_expect_* functions instead.
824
825 test_ok_ () {
826         if test "$test_subtest_known_broken_" = "t"; then
827                 test_known_broken_ok_
828                 return
829         fi
830         test_success=$(($test_success + 1))
831         if test -n "$NOTMUCH_TEST_QUIET"; then
832                 return 0
833         fi
834         say_color pass "%-6s" "PASS"
835         echo " $test_subtest_name"
836 }
837
838 test_failure_ () {
839         if test "$test_subtest_known_broken_" = "t"; then
840                 test_known_broken_failure_ "$@"
841                 return
842         fi
843         test_failure=$(($test_failure + 1))
844         print_test_description
845         test_failure_message_ "FAIL" "$test_subtest_name" "$@"
846         test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
847         return 1
848 }
849
850 test_failure_message_ () {
851         say_color error "%-6s" "$1"
852         echo " $2"
853         shift 2
854         echo "$@" | sed -e 's/^/        /'
855         if test "$verbose" != "t"; then cat test.output; fi
856 }
857
858 test_known_broken_ok_ () {
859         test_reset_state_
860         test_fixed=$(($test_fixed+1))
861         say_color pass "%-6s" "FIXED"
862         echo " $test_subtest_name"
863 }
864
865 test_known_broken_failure_ () {
866         test_reset_state_
867         test_broken=$(($test_broken+1))
868         test_failure_message_ "BROKEN" "$test_subtest_name" "$@"
869         return 1
870 }
871
872 test_debug () {
873         test "$debug" = "" || eval "$1"
874 }
875
876 test_run_ () {
877         test_cleanup=:
878         if test "$verbose" != "t"; then exec 4>test.output 3>&4; fi
879         eval >&3 2>&4 "$1"
880         eval_ret=$?
881         eval >&3 2>&4 "$test_cleanup"
882         return 0
883 }
884
885 test_skip () {
886         test_count=$(($test_count+1))
887         to_skip=
888         for skp in $NOTMUCH_SKIP_TESTS
889         do
890                 case $this_test.$test_count in
891                 $skp)
892                         to_skip=t
893                         break
894                 esac
895                 case $this_test_bare.$test_count in
896                 $skp)
897                         to_skip=t
898                         break
899                 esac
900         done
901         if test -z "$to_skip" && test -n "$prereq" &&
902            ! test_have_prereq "$prereq"
903         then
904                 to_skip=t
905         fi
906         case "$to_skip" in
907         t)
908                 test_report_skip_ "$@"
909                 ;;
910         *)
911                 test_check_missing_external_prereqs_ "$@"
912                 ;;
913         esac
914 }
915
916 test_check_missing_external_prereqs_ () {
917         if [[ ${#test_subtest_missing_external_prereq_[@]} != 0 ]]; then
918                 say_color skip >&1 "missing prerequisites: "
919                 echo ${!test_subtest_missing_external_prereq_[@]} >&1
920                 test_report_skip_ "$@"
921         else
922                 false
923         fi
924 }
925
926 test_report_skip_ () {
927         test_reset_state_
928         say_color skip >&3 "skipping test:"
929         echo " $@" >&3
930         say_color skip "%-6s" "SKIP"
931         echo " $1"
932 }
933
934 test_subtest_known_broken () {
935         test_subtest_known_broken_=t
936 }
937
938 test_expect_success () {
939         test "$#" = 3 && { prereq=$1; shift; } || prereq=
940         test "$#" = 2 ||
941         error "bug in the test script: not 2 or 3 parameters to test-expect-success"
942         test_subtest_name="$1"
943         test_reset_state_
944         if ! test_skip "$@"
945         then
946                 test_run_ "$2"
947                 run_ret="$?"
948                 # test_run_ may update missing external prerequisites
949                 test_check_missing_external_prereqs_ "$@" ||
950                 if [ "$run_ret" = 0 -a "$eval_ret" = 0 ]
951                 then
952                         test_ok_
953                 else
954                         test_failure_ "$2"
955                 fi
956         fi
957 }
958
959 test_expect_code () {
960         test "$#" = 4 && { prereq=$1; shift; } || prereq=
961         test "$#" = 3 ||
962         error "bug in the test script: not 3 or 4 parameters to test-expect-code"
963         test_subtest_name="$2"
964         test_reset_state_
965         if ! test_skip "$@"
966         then
967                 test_run_ "$3"
968                 run_ret="$?"
969                 # test_run_ may update missing external prerequisites,
970                 test_check_missing_external_prereqs_ "$@" ||
971                 if [ "$run_ret" = 0 -a "$eval_ret" = "$1" ]
972                 then
973                         test_ok_
974                 else
975                         test_failure_ "exit code $eval_ret, expected $1" "$3"
976                 fi
977         fi
978 }
979
980 # test_external runs external test scripts that provide continuous
981 # test output about their progress, and succeeds/fails on
982 # zero/non-zero exit code.  It outputs the test output on stdout even
983 # in non-verbose mode, and announces the external script with "* run
984 # <n>: ..." before running it.  When providing relative paths, keep in
985 # mind that all scripts run in "trash directory".
986 # Usage: test_external description command arguments...
987 # Example: test_external 'Perl API' perl ../path/to/test.pl
988 test_external () {
989         test "$#" = 4 && { prereq=$1; shift; } || prereq=
990         test "$#" = 3 ||
991         error >&6 "bug in the test script: not 3 or 4 parameters to test_external"
992         test_subtest_name="$1"
993         shift
994         test_reset_state_
995         if ! test_skip "$test_subtest_name" "$@"
996         then
997                 # Announce the script to reduce confusion about the
998                 # test output that follows.
999                 say_color "" " run $test_count: $descr ($*)"
1000                 # Run command; redirect its stderr to &4 as in
1001                 # test_run_, but keep its stdout on our stdout even in
1002                 # non-verbose mode.
1003                 "$@" 2>&4
1004                 if [ "$?" = 0 ]
1005                 then
1006                         test_ok_
1007                 else
1008                         test_failure_ "$@"
1009                 fi
1010         fi
1011 }
1012
1013 # Like test_external, but in addition tests that the command generated
1014 # no output on stderr.
1015 test_external_without_stderr () {
1016         # The temporary file has no (and must have no) security
1017         # implications.
1018         tmp="$TMPDIR"; if [ -z "$tmp" ]; then tmp=/tmp; fi
1019         stderr="$tmp/git-external-stderr.$$.tmp"
1020         test_external "$@" 4> "$stderr"
1021         [ -f "$stderr" ] || error "Internal error: $stderr disappeared."
1022         test_subtest_name="no stderr: $1"
1023         shift
1024         if [ ! -s "$stderr" ]; then
1025                 rm "$stderr"
1026                 test_ok_
1027         else
1028                 if [ "$verbose" = t ]; then
1029                         output=`echo; echo Stderr is:; cat "$stderr"`
1030                 else
1031                         output=
1032                 fi
1033                 # rm first in case test_failure exits.
1034                 rm "$stderr"
1035                 test_failure_ "$@" "$output"
1036         fi
1037 }
1038
1039 # This is not among top-level (test_expect_success)
1040 # but is a prefix that can be used in the test script, like:
1041 #
1042 #       test_expect_success 'complain and die' '
1043 #           do something &&
1044 #           do something else &&
1045 #           test_must_fail git checkout ../outerspace
1046 #       '
1047 #
1048 # Writing this as "! git checkout ../outerspace" is wrong, because
1049 # the failure could be due to a segv.  We want a controlled failure.
1050
1051 test_must_fail () {
1052         "$@"
1053         test $? -gt 0 -a $? -le 129 -o $? -gt 192
1054 }
1055
1056 # test_cmp is a helper function to compare actual and expected output.
1057 # You can use it like:
1058 #
1059 #       test_expect_success 'foo works' '
1060 #               echo expected >expected &&
1061 #               foo >actual &&
1062 #               test_cmp expected actual
1063 #       '
1064 #
1065 # This could be written as either "cmp" or "diff -u", but:
1066 # - cmp's output is not nearly as easy to read as diff -u
1067 # - not all diff versions understand "-u"
1068
1069 test_cmp() {
1070         $GIT_TEST_CMP "$@"
1071 }
1072
1073 # This function can be used to schedule some commands to be run
1074 # unconditionally at the end of the test to restore sanity:
1075 #
1076 #       test_expect_success 'test core.capslock' '
1077 #               git config core.capslock true &&
1078 #               test_when_finished "git config --unset core.capslock" &&
1079 #               hello world
1080 #       '
1081 #
1082 # That would be roughly equivalent to
1083 #
1084 #       test_expect_success 'test core.capslock' '
1085 #               git config core.capslock true &&
1086 #               hello world
1087 #               git config --unset core.capslock
1088 #       '
1089 #
1090 # except that the greeting and config --unset must both succeed for
1091 # the test to pass.
1092
1093 test_when_finished () {
1094         test_cleanup="{ $*
1095                 } && (exit \"\$eval_ret\"); eval_ret=\$?; $test_cleanup"
1096 }
1097
1098 test_done () {
1099         GIT_EXIT_OK=t
1100         test_results_dir="$TEST_DIRECTORY/test-results"
1101         mkdir -p "$test_results_dir"
1102         test_results_path="$test_results_dir/$this_test"
1103
1104         echo "total $test_count" >> $test_results_path
1105         echo "success $test_success" >> $test_results_path
1106         echo "fixed $test_fixed" >> $test_results_path
1107         echo "broken $test_broken" >> $test_results_path
1108         echo "failed $test_failure" >> $test_results_path
1109         echo "" >> $test_results_path
1110
1111         [ -n "$EMACS_SERVER" ] && test_emacs '(kill-emacs)'
1112
1113         if [ "$test_failure" = "0" ]; then
1114             if [ "$test_broken" = "0" ]; then
1115                 rm -rf "$remove_tmp"
1116             fi
1117             exit 0
1118         else
1119             exit 1
1120         fi
1121 }
1122
1123 emacs_generate_script () {
1124         # Construct a little test script here for the benefit of the user,
1125         # (who can easily run "run_emacs" to get the same emacs environment
1126         # for investigating any failures).
1127         cat <<EOF >"$TMP_DIRECTORY/run_emacs"
1128 #!/bin/sh
1129 export PATH=$PATH
1130 export NOTMUCH_CONFIG=$NOTMUCH_CONFIG
1131
1132 # Here's what we are using here:
1133 #
1134 # --quick              Use minimal customization. This implies --no-init-file,
1135 #                      --no-site-file and (emacs 24) --no-site-lisp
1136 #
1137 # --directory           Ensure that the local elisp sources are found
1138 #
1139 # --load                Force loading of notmuch.el and test-lib.el
1140
1141 exec ${TEST_EMACS} --quick \
1142         --directory "$TEST_DIRECTORY/../emacs" --load notmuch.el \
1143         --directory "$TEST_DIRECTORY" --load test-lib.el \
1144         "\$@"
1145 EOF
1146         chmod a+x "$TMP_DIRECTORY/run_emacs"
1147 }
1148
1149 test_emacs () {
1150         # test dependencies beforehand to avoid the waiting loop below
1151         missing_dependencies=
1152         test_require_external_prereq dtach || missing_dependencies=1
1153         test_require_external_prereq emacs || missing_dependencies=1
1154         test_require_external_prereq ${TEST_EMACSCLIENT} || missing_dependencies=1
1155         test -z "$missing_dependencies" || return
1156
1157         if [ -z "$EMACS_SERVER" ]; then
1158                 emacs_tests="${this_test_bare}.el"
1159                 if [ -f "$TEST_DIRECTORY/$emacs_tests" ]; then
1160                         load_emacs_tests="--eval '(load \"$emacs_tests\")'"
1161                 else
1162                         load_emacs_tests=
1163                 fi
1164                 server_name="notmuch-test-suite-$$"
1165                 # start a detached session with an emacs server
1166                 # user's TERM (or 'vt100' in case user's TERM is unset, empty
1167                 # or 'dumb') is given to dtach which assumes a minimally
1168                 # VT100-compatible terminal -- and emacs inherits that
1169                 TERM=$DTACH_TERM dtach -n "$TEST_TMPDIR/emacs-dtach-socket.$$" \
1170                         sh -c "stty rows 24 cols 80; exec '$TMP_DIRECTORY/run_emacs' \
1171                                 --no-window-system \
1172                                 $load_emacs_tests \
1173                                 --eval '(setq server-name \"$server_name\")' \
1174                                 --eval '(server-start)' \
1175                                 --eval '(orphan-watchdog $$)'" || return
1176                 EMACS_SERVER="$server_name"
1177                 # wait until the emacs server is up
1178                 until test_emacs '()' >/dev/null 2>/dev/null; do
1179                         sleep 1
1180                 done
1181         fi
1182
1183         # Clear test-output output file.  Most Emacs tests end with a
1184         # call to (test-output).  If the test code fails with an
1185         # exception before this call, the output file won't get
1186         # updated.  Since we don't want to compare against an output
1187         # file from another test, so start out with an empty file.
1188         rm -f OUTPUT
1189         touch OUTPUT
1190
1191         ${TEST_EMACSCLIENT} --socket-name="$EMACS_SERVER" --eval "(notmuch-test-progn $@)"
1192 }
1193
1194 test_python() {
1195         export LD_LIBRARY_PATH=$TEST_DIRECTORY/../lib
1196         export PYTHONPATH=$TEST_DIRECTORY/../bindings/python
1197
1198         (echo "import sys; _orig_stdout=sys.stdout; sys.stdout=open('OUTPUT', 'w')"; cat) \
1199                 | $NOTMUCH_PYTHON -
1200 }
1201
1202 test_ruby() {
1203     export LD_LIBRARY_PATH=$TEST_DIRECTORY/../lib
1204     MAIL_DIR=$MAIL_DIR ruby -I $TEST_DIRECTORY/../bindings/ruby> OUTPUT
1205 }
1206
1207 test_C () {
1208     exec_file="test${test_count}"
1209     test_file="${exec_file}.c"
1210     cat > ${test_file}
1211     export LD_LIBRARY_PATH=${TEST_DIRECTORY}/../lib
1212     ${TEST_CC} ${TEST_CFLAGS} -I${TEST_DIRECTORY}/../lib -o ${exec_file} ${test_file} -L${TEST_DIRECTORY}/../lib/ -lnotmuch -ltalloc
1213     echo "== stdout ==" > OUTPUT.stdout
1214     echo "== stderr ==" > OUTPUT.stderr
1215     ./${exec_file} "$@" 1>>OUTPUT.stdout 2>>OUTPUT.stderr
1216     notmuch_dir_sanitize OUTPUT.stdout OUTPUT.stderr > OUTPUT
1217 }
1218
1219
1220 # Creates a script that counts how much time it is executed and calls
1221 # notmuch.  $notmuch_counter_command is set to the path to the
1222 # generated script.  Use notmuch_counter_value() function to get the
1223 # current counter value.
1224 notmuch_counter_reset () {
1225         notmuch_counter_command="$TMP_DIRECTORY/notmuch_counter"
1226         if [ ! -x "$notmuch_counter_command" ]; then
1227                 notmuch_counter_state_path="$TMP_DIRECTORY/notmuch_counter.state"
1228                 cat >"$notmuch_counter_command" <<EOF || return
1229 #!/bin/sh
1230
1231 read count < "$notmuch_counter_state_path"
1232 echo \$((count + 1)) > "$notmuch_counter_state_path"
1233
1234 exec notmuch "\$@"
1235 EOF
1236                 chmod +x "$notmuch_counter_command" || return
1237         fi
1238
1239         echo 0 > "$notmuch_counter_state_path"
1240 }
1241
1242 # Returns the current notmuch counter value.
1243 notmuch_counter_value () {
1244         if [ -r "$notmuch_counter_state_path" ]; then
1245                 read count < "$notmuch_counter_state_path"
1246         else
1247                 count=0
1248         fi
1249         echo $count
1250 }
1251
1252 test_reset_state_ () {
1253         test -z "$test_init_done_" && test_init_
1254
1255         test_subtest_known_broken_=
1256         test_subtest_missing_external_prereq_=()
1257 }
1258
1259 # called once before the first subtest
1260 test_init_ () {
1261         test_init_done_=t
1262
1263         # skip all tests if there were external prerequisites missing during init
1264         test_check_missing_external_prereqs_ "all tests in $this_test" && test_done
1265 }
1266
1267
1268 . ./test-lib-common.sh || exit 1
1269
1270 emacs_generate_script
1271
1272
1273 # Use -P to resolve symlinks in our working directory so that the cwd
1274 # in subprocesses like git equals our $PWD (for pathname comparisons).
1275 cd -P "$test" || error "Cannot set up test environment"
1276
1277 if test "$verbose" = "t"
1278 then
1279         exec 4>&2 3>&1
1280 else
1281         exec 4>test.output 3>&4
1282 fi
1283
1284 for skp in $NOTMUCH_SKIP_TESTS
1285 do
1286         to_skip=
1287         for skp in $NOTMUCH_SKIP_TESTS
1288         do
1289                 case "$this_test" in
1290                 $skp)
1291                         to_skip=t
1292                         break
1293                 esac
1294                 case "$this_test_bare" in
1295                 $skp)
1296                         to_skip=t
1297                         break
1298                 esac
1299         done
1300         case "$to_skip" in
1301         t)
1302                 say_color skip >&3 "skipping test $this_test altogether"
1303                 say_color skip "skip all tests in $this_test"
1304                 test_done
1305         esac
1306 done
1307
1308 # Provide an implementation of the 'yes' utility
1309 yes () {
1310         if test $# = 0
1311         then
1312                 y=y
1313         else
1314                 y="$*"
1315         fi
1316
1317         while echo "$y"
1318         do
1319                 :
1320         done
1321 }
1322
1323 # Fix some commands on Windows
1324 case $(uname -s) in
1325 *MINGW*)
1326         # Windows has its own (incompatible) sort and find
1327         sort () {
1328                 /usr/bin/sort "$@"
1329         }
1330         find () {
1331                 /usr/bin/find "$@"
1332         }
1333         sum () {
1334                 md5sum "$@"
1335         }
1336         # git sees Windows-style pwd
1337         pwd () {
1338                 builtin pwd -W
1339         }
1340         # no POSIX permissions
1341         # backslashes in pathspec are converted to '/'
1342         # exec does not inherit the PID
1343         ;;
1344 *)
1345         test_set_prereq POSIXPERM
1346         test_set_prereq BSLASHPSPEC
1347         test_set_prereq EXECKEEPSPID
1348         ;;
1349 esac
1350
1351 test -z "$NO_PERL" && test_set_prereq PERL
1352 test -z "$NO_PYTHON" && test_set_prereq PYTHON
1353
1354 # test whether the filesystem supports symbolic links
1355 ln -s x y 2>/dev/null && test -h y 2>/dev/null && test_set_prereq SYMLINKS
1356 rm -f y
1357
1358 # convert variable from configure to more convenient form
1359 case "$NOTMUCH_DEFAULT_XAPIAN_BACKEND" in
1360     glass)
1361         db_ending=glass
1362     ;;
1363     chert)
1364         db_ending=DB
1365     ;;
1366     *)
1367         error "Unknown Xapian backend $NOTMUCH_DEFAULT_XAPIAN_BACKEND"
1368 esac
1369 # declare prerequisites for external binaries used in tests
1370 test_declare_external_prereq dtach
1371 test_declare_external_prereq emacs
1372 test_declare_external_prereq ${TEST_EMACSCLIENT}
1373 test_declare_external_prereq gdb
1374 test_declare_external_prereq gpg
1375 test_declare_external_prereq openssl
1376 test_declare_external_prereq gpgsm
1377 test_declare_external_prereq ${NOTMUCH_PYTHON}